/*
===========================================================================
Copyright (C) 1999-2005 Id Software, Inc.
Copyright (C) 2006 Robert Beckebans <trebor_7@users.sourceforge.net>

This file is part of XreaL source code.

XreaL source code is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License as
published by the Free Software Foundation; either version 2 of the License,
or (at your option) any later version.

XreaL source code is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with XreaL source code; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
===========================================================================
*/
// piclib.h


void            LoadLBM(const char *filename, byte ** picture, byte ** palette);
void            WriteLBMfile(const char *filename, byte * data, int width, int height, byte * palette);
void            LoadPCX(const char *filename, byte ** picture, byte ** palette, int *width, int *height);
void            WritePCXfile(const char *filename, byte * data, int width, int height, byte * palette);

// loads / saves either lbm or pcx, depending on extension
void            Load256Image(const char *name, byte ** pixels, byte ** palette, int *width, int *height);
void            Save256Image(const char *name, byte * pixels, byte * palette, int width, int height);


void            LoadTGA(const char *filename, byte ** pixels, int *width, int *height);
void            LoadTGABuffer(byte * buffer, byte ** pic, int *width, int *height);
void            WriteTGA(const char *filename, byte * data, int width, int height);

void            Load32BitImage(const char *name, unsigned **pixels, int *width, int *height);

void            LoadJPGBuffer(const char *filename, byte * fbuffer, int fbufferSize, byte ** pic, int *width, int *height);

void            LoadPNGBuffer(byte * buffer, byte ** pic, int *width, int *height);
void            WritePNG(const char *filename, const byte * data, int width, int height, int numBytesPerPixel, qboolean flip);
